﻿Procedure WalkDirectoryTree(Path.s, List Files.s(), EXTPARM.s = "*.*", State.b = 1)
  Protected Path$, File$, Retr_ID

  If State
    If Right(Path, 1) <> "\" : Path$ + "\" : EndIf

    ClearList(Files())
  EndIf

  Retr_ID = ExamineDirectory(#PB_Any, Path, EXTPARM)
  If Retr_ID
    While NextDirectoryEntry(Retr_ID)
      Select DirectoryEntryType(Retr_ID)
        Case #PB_DirectoryEntry_File
          File$ = DirectoryEntryName(Retr_ID)

          AddElement(Files())
          Files() = Path+File$

        Case #PB_DirectoryEntry_Directory
          Select DirectoryEntryName(Retr_ID)
            Case ".", ".."
              Continue
            Default

              Path$ = Path + DirectoryEntryName(Retr_ID) + "\"
              Debug Path$

              WalkDirectoryTree(Path$, Files(), EXTPARM, 0)
          EndSelect
      EndSelect
    Wend
    FinishDirectory(Retr_ID)

    ProcedureReturn 1
  EndIf

  ProcedureReturn 0
EndProcedure


CompilerIf #PB_Compiler_IsMainFile

  NewList GetFiles.s()

  Path$ = "C:\Program Files\Internet Explorer\"

  If WalkDirectoryTree(Path$, GetFiles(), "*.*")
    ForEach GetFiles()
      Debug GetFiles()
    Next
  EndIf

CompilerEndIf

; IDE Options = PureBasic 5.44 LTS (Windows - x64)
; CursorPosition = 43
; FirstLine = 33
; Folding = -
; EnableUnicode
; EnableXP
; EnablePurifier